"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var divkit_jsbundle_core_1 = require("divkit.jsbundle.core");
var divkit_jsbundle_drawing_1 = require("divkit.jsbundle.drawing");
var MisclickEventArgs_1 = require("./MisclickEventArgs");
var GesturingEventArgs_1 = require("./GesturingEventArgs");
var TapEventArgs_1 = require("./TapEventArgs");
var MoveEventArgs_1 = require("./MoveEventArgs");
var GestureHistory_1 = require("./GestureHistory");
var GestureSupportElement = (function () {
    function GestureSupportElement(el, renderer) {
        this.renderer = renderer;
        this.OnMisclick = new core_1.EventEmitter();
        this.OnInitialize = new core_1.EventEmitter();
        this.OnDrawing = new core_1.EventEmitter();
        this.OnDrawingCompleted = new core_1.EventEmitter();
        this.OnTap = new core_1.EventEmitter();
        this.OnMove = new core_1.EventEmitter();
        this.OnMoveEnd = new core_1.EventEmitter();
        this.ClearOnLeave = false;
        this.AutoTidy = true;
        this.TidyThreshold = 20;
        this.SlopeThreshold = .1;
        this.PreventDefault = true;
        this.MouseButtons = [1];
        this.FullBounds = false;
        this.FullHistory = false;
        this.UpdateBoundsOnMove = true;
        this.DetectMisclick = false;
        this.IsDraggableElement = false;
        this.__history = [];
        this.__tapCount = 0;
        this.__tapDelay = 300;
        this.__container = el.nativeElement;
    }
    Object.defineProperty(GestureSupportElement.prototype, "Drawing", {
        get: function () {
            return this.__drawing;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GestureSupportElement.prototype, "History", {
        get: function () {
            return this.__history;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GestureSupportElement.prototype, "Bounds", {
        get: function () {
            return this.__bounds;
        },
        enumerable: true,
        configurable: true
    });
    GestureSupportElement.prototype.IsCorrectButton = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (args[0]) {
            return this.MouseButtons.indexOf(args[0]) > -1;
        }
        var button = args[1] || args[2];
        return this.MouseButtons.indexOf(button) > -1;
    };
    GestureSupportElement.prototype.onMouseDown = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (this.GestureDisabled ||
            !this.IsCorrectButton(args[3], args[4], args[5])) {
        }
        else {
            this.Initialize(args[0], args[1], args[2]);
        }
        if (this.PreventDefault && !this.DetectMisclick) {
            return false;
        }
    };
    GestureSupportElement.prototype.onMouseUp = function () {
        this.TapEndHandler();
    };
    GestureSupportElement.prototype.onMouseMove = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (!this.GestureDisabled && this.__drawing && this.__focusIn) {
            var pos = new divkit_jsbundle_drawing_1.Vector(args[0] - this.__parentOffset.X, args[1] - this.__parentOffset.Y);
            if (this.IsDraggableElement) {
                this.MoveTo(args[0], args[1]);
                return;
            }
            this.__current = pos;
            this.__history.push(new GestureHistory_1.GestureHistory(pos, Date.now()));
            this.CheckForTidy();
            if (this.UpdateBoundsOnMove) {
                this.GesturingEventHandler(false);
            }
        }
    };
    GestureSupportElement.prototype.onMouseLeave = function () {
        if (!this.GestureDisabled) {
            if (this.__drawing && this.ClearOnLeave) {
                if (this.AutoTidy) {
                    this.Tidy();
                }
                this.GesturingEventHandler(true);
            }
            this.__focusIn = false;
        }
    };
    GestureSupportElement.prototype.onMouseEnter = function () {
        if (!this.GestureDisabled)
            this.__focusIn = true;
    };
    GestureSupportElement.prototype.onTouchStart = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (!this.GestureDisabled && args[2].length === 1) {
            this.Initialize(args[0], args[1], args[3]);
        }
        if (this.PreventDefault) {
            return false;
        }
    };
    GestureSupportElement.prototype.onTouchMove = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (!this.GestureDisabled && this.__drawing && this.__focusIn) {
            var pos = new divkit_jsbundle_drawing_1.Vector(args[0] - this.__parentOffset.X, args[1] - this.__parentOffset.Y);
            this.__current = pos;
            this.__history.push(new GestureHistory_1.GestureHistory(pos, Date.now()));
            this.CheckForTidy();
            if (this.UpdateBoundsOnMove) {
                this.GesturingEventHandler(false);
            }
        }
    };
    GestureSupportElement.prototype.onTouchEnd = function () {
        this.TapEndHandler();
    };
    GestureSupportElement.prototype.onTouchCancel = function () {
        if (!this.GestureDisabled) {
            if (this.__drawing && this.ClearOnLeave) {
                this.__drawing = false;
                if (this.AutoTidy) {
                    this.Tidy();
                }
            }
            this.GesturingEventHandler(true);
        }
    };
    GestureSupportElement.prototype.TapEndHandler = function () {
        if (!this.GestureDisabled && this.__drawing && this.__focusIn) {
            this.__drawing = false;
            this.CheckTapCount();
            if (this.AutoTidy) {
                this.Tidy();
            }
            this.GesturingEventHandler(true);
        }
    };
    GestureSupportElement.prototype.CheckTapCount = function () {
        if (new Date(Date.now() - this.__tapTime).getMilliseconds() <= this.__tapDelay) {
            clearTimeout(this.__tapTimeout);
            this.__tapCount++;
            this.__tapTimeout = setTimeout(function (a) {
                a.OnTap.emit(new TapEventArgs_1.TapEventArgs(a.__tapCount, a.__begin));
                a.__tapCount = 0;
            }, this.__tapDelay, this);
            return true;
        }
        return false;
    };
    GestureSupportElement.prototype.Initialize = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        this.__tapTime = Date.now();
        this.__history = [];
        this.__drawing = this.__focusIn = true;
        this.__parentOffset = divkit_jsbundle_core_1.Screen.GetPosition(this.__container);
        this.__begin = new divkit_jsbundle_drawing_1.Vector(args[0] - this.__parentOffset.X, args[1] - this.__parentOffset.Y);
        this.__current = this.__begin;
        this.__bounds = new divkit_jsbundle_drawing_1.Vector(this.__current, this.__begin);
        if (this.DetectMisclick && args[2] !== this.__container)
            this.OnMisclick.emit(new MisclickEventArgs_1.MisclickEventArgs(args[2]));
    };
    GestureSupportElement.prototype.MoveTo = function (x, y) {
        if (!x || !y)
            return;
        this.__current = new divkit_jsbundle_drawing_1.Vector(this.__parentOffset.X + x - this.__begin.X, this.__parentOffset.Y + y - this.__begin.Y);
        this.SetLocation(this.__current);
        this.OnMove.emit(new MoveEventArgs_1.MoveEventArgs(this, this.__parentOffset, this.__current));
    };
    GestureSupportElement.prototype.SetLocation = function (point) {
        this.renderer.setElementStyle(this.__container, 'top', point.Y + 'px');
        this.renderer.setElementStyle(this.__container, 'left', point.X + 'px');
    };
    GestureSupportElement.prototype.GetBounds = function () {
        if (this.__history.length <= 1) {
            return divkit_jsbundle_drawing_1.Bounds.Create(this.__begin, this.__current);
        }
        if (this.FullBounds) {
            var a = void 0, b = void 0, c = void 0, d = void 0, e = void 0, f = void 0;
            a = b = 10000;
            e = f = -10000;
            for (c = 0; c < this.__history.length; c++) {
                d = this.__history[c].Location;
                if (d.X < a)
                    a = d.X;
                if (d.X > e)
                    e = d.X;
                if (d.Y < b)
                    b = d.Y;
                if (d.Y > f)
                    f = d.Y;
            }
            return divkit_jsbundle_drawing_1.Bounds.Create(a, b, e, f);
        }
        return divkit_jsbundle_drawing_1.Bounds.Create(this.__begin, this.__current);
    };
    GestureSupportElement.prototype.GesturingEventHandler = function (complete) {
        this.__bounds = this.GetBounds();
        var output = new GesturingEventArgs_1.GesturingEventArgs(this.__bounds, this.FullHistory ? this.__history : [this.__history[this.__history.length]]);
        this.OnDrawing.emit(output);
        if (complete) {
            this.OnDrawingCompleted.emit(output);
        }
    };
    GestureSupportElement.prototype.CheckForTidy = function () {
        if (this.__history.length > this.TidyThreshold && this.AutoTidy) {
            this.Tidy();
        }
    };
    GestureSupportElement.prototype.Tidy = function () {
        var h, i, a, b, c, e, m1, m2, s, r;
        h = this.__history;
        s = this.SlopeThreshold;
        if (h.length < 3)
            return;
        for (i = 0; i < h.length; i++) {
            e = false;
            a = h[i].Location;
            h[i + 2] ? c = h[i + 2].Location : e = true;
            if (e)
                continue;
            b = h[i + 1].Location;
            m1 = (b.Y - a.Y) / (b.X - a.X);
            m2 = (c.Y - b.Y) / (c.X - b.X);
            if ((m1 - m2) <= s && (m1 - m2) >= 0) {
                h.splice(i + 1, 1);
                ++i;
            }
        }
        this.__history = h;
    };
    GestureSupportElement.prototype.ngOnInit = function () {
        this.OnInitialize.emit(this);
    };
    __decorate([
        core_1.Output("gesture-input-misclick"), 
        __metadata('design:type', core_1.EventEmitter)
    ], GestureSupportElement.prototype, "OnMisclick", void 0);
    __decorate([
        core_1.Output("gesture-input-init"), 
        __metadata('design:type', core_1.EventEmitter)
    ], GestureSupportElement.prototype, "OnInitialize", void 0);
    __decorate([
        core_1.Output("gesture-input-drawing"), 
        __metadata('design:type', core_1.EventEmitter)
    ], GestureSupportElement.prototype, "OnDrawing", void 0);
    __decorate([
        core_1.Output("gesture-input-drawing-completed"), 
        __metadata('design:type', core_1.EventEmitter)
    ], GestureSupportElement.prototype, "OnDrawingCompleted", void 0);
    __decorate([
        core_1.Output("gesture-input-tap"), 
        __metadata('design:type', core_1.EventEmitter)
    ], GestureSupportElement.prototype, "OnTap", void 0);
    __decorate([
        core_1.Output('draggable-move'), 
        __metadata('design:type', core_1.EventEmitter)
    ], GestureSupportElement.prototype, "OnMove", void 0);
    __decorate([
        core_1.Output('draggable-moveend'), 
        __metadata('design:type', core_1.EventEmitter)
    ], GestureSupportElement.prototype, "OnMoveEnd", void 0);
    __decorate([
        core_1.Input("gesture-input-disabled"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "GestureDisabled", void 0);
    __decorate([
        core_1.Input("gesture-input-clearonleave"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "ClearOnLeave", void 0);
    __decorate([
        core_1.Input("gesture-autotidy"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "AutoTidy", void 0);
    __decorate([
        core_1.Input("gesture-tidythreshold"), 
        __metadata('design:type', Number)
    ], GestureSupportElement.prototype, "TidyThreshold", void 0);
    __decorate([
        core_1.Input("gesture-slopethreshold"), 
        __metadata('design:type', Number)
    ], GestureSupportElement.prototype, "SlopeThreshold", void 0);
    __decorate([
        core_1.Input("gesture-preventdefault"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "PreventDefault", void 0);
    __decorate([
        core_1.Input("gesture-mousebuttons"), 
        __metadata('design:type', Array)
    ], GestureSupportElement.prototype, "MouseButtons", void 0);
    __decorate([
        core_1.Input("gesture-fullbounds"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "FullBounds", void 0);
    __decorate([
        core_1.Input("gesture-fullhistory"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "FullHistory", void 0);
    __decorate([
        core_1.Input("gesture-updateonmove"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "UpdateBoundsOnMove", void 0);
    __decorate([
        core_1.Input("gesture-detectmisclick"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "DetectMisclick", void 0);
    __decorate([
        core_1.Input("gesure-isdraggable"), 
        __metadata('design:type', Boolean)
    ], GestureSupportElement.prototype, "IsDraggableElement", void 0);
    __decorate([
        core_1.HostListener("mousedown", ['$event.clientX', '$event.clientY', '$event.target', '$event.buttons', '$event.which', '$event.button']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onMouseDown", null);
    __decorate([
        core_1.HostListener("mouseup"), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onMouseUp", null);
    __decorate([
        core_1.HostListener("mousemove", ['$event.clientX', '$event.clientY']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onMouseMove", null);
    __decorate([
        core_1.HostListener("mouseleave"), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onMouseLeave", null);
    __decorate([
        core_1.HostListener("mouseenter"), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onMouseEnter", null);
    __decorate([
        core_1.HostListener("touchstart", ['$event.touches[0].clientX', '$event.touches[0].clientY', '$event.touches', '$event.target']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onTouchStart", null);
    __decorate([
        core_1.HostListener("touchmove", ['$event.touches[0].clientX', '$event.touches[0].clientY']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', [Object]), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onTouchMove", null);
    __decorate([
        core_1.HostListener("touchend"), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onTouchEnd", null);
    __decorate([
        core_1.HostListener("touchcancel"), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], GestureSupportElement.prototype, "onTouchCancel", null);
    GestureSupportElement = __decorate([
        core_1.Directive({
            selector: "[ng2-gesture-input]",
            exportAs: "gesture-instance"
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.Renderer])
    ], GestureSupportElement);
    return GestureSupportElement;
}());
exports.GestureSupportElement = GestureSupportElement;
var GestureSupportModule = (function () {
    function GestureSupportModule() {
    }
    GestureSupportModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            declarations: [GestureSupportElement],
            exports: [GestureSupportElement]
        }), 
        __metadata('design:paramtypes', [])
    ], GestureSupportModule);
    return GestureSupportModule;
}());
exports.GestureSupportModule = GestureSupportModule;
//# sourceMappingURL=GestureSupportElement.js.map